
section .text

compress_rawdat:
  push rbx
  push rcx
  push rdx
  push rsi
  push rdi
  xor  rsi,rsi
  mov  esi,[timf1p_pa]
  add  rsi,[timf1_char]
  mov  rdi,[rawsave_tmp]
  mov  ebx,[rx_read_bytes]
; Compress 4 byte words (int) to 18 bit.
cmpr:
  mov  ax,[rsi+2]      ;byte 2,3  of word 0
  mov  ch,[rsi+1]      ;byte 1 of word 0
  mov  [rdi],ax
  shr  ch,2
  mov  ax,[rsi+6]      ;byte 2,3  of word 1
  mov  cl,[rsi+5]      ;byte 1 of word 1
  mov  [rdi+2],ax
  and  cl,11000000B
  or   ch,cl
  shr  ch,2
  mov  ax,[rsi+10]      ;byte 2,3  of word 2
  mov  cl,[rsi+ 9]      ;byte 1 of word 2
  mov  [rdi+4],ax
  and  cl,11000000B
  or   ch,cl
  shr  ch,2
  mov  ax,[rsi+14]      ;byte 2,3  of word 3
  mov  cl,[rsi+13]      ;byte 1 of word 3
  and  cl,11000000B
  or   ch,cl
  mov  [rdi+6],ax
  mov  [rdi+8],ch
  add  rsi,16
  add  rdi,9
  sub  ebx,16
  ja   cmpr
zzz:
  pop  rdi
  pop  rsi
  pop  rdx
  pop  rcx
  pop  rbx
  ret


expand_rawdat:
  push rbx
  push rcx
  push rdx
  push rsi
  push rdi
  xor  rsi,rsi
  mov  esi,[timf1p_pa]
  add  rsi,[timf1_char]
  mov  rdi,[rawsave_tmp]
  mov  ebx,[rx_read_bytes]
; Expand 18 bit packed data.
; add 0.5 bits (=bit 19) to correct for the average error
; of 0.5 bits that we introduced by truncating to 18 bits.
; This will remove the spur at frequency=0 that would otherwise
; have been introduced
expnd:
  mov  eax,[rdi-2]    
  mov  ecx,[rdi+6]
  xor  cx,cx  
  shr  ecx,2
  mov  ax,cx
  add  eax,0x2000
  mov  [rsi],eax
  mov  eax,[rdi]
  xor  cx,cx  
  shr  ecx,2
  mov  ax,cx
  add  eax,0x2000
  mov  [rsi+4],eax
  mov  eax,[rdi+2]
  xor  cx,cx  
  shr  ecx,2
  mov  ax,cx
  add  eax,0x2000
  mov  [rsi+8],eax
  mov  eax,[rdi+4]
  xor  cx,cx  
  shr  ecx,2
  mov  ax,cx
  add  eax,0x2000
  mov  [rsi+12],eax
  add  rsi,16
  add  rdi,9
  sub  ebx,16
  ja   expnd
  pop  rdi
  pop  rsi
  pop  rdx
  pop  rcx
  pop  rbx
  ret





